#include"TcPch.h"
#pragma hdrstop
#include"IoAPC.h"
#include"DEVICE.h"
#include"debug.h"
IoAPC::IoAPC(const char* className,const char* name,const char* module):BaseDevice(className, name, module){
}
//AUTOIO_BEGIN
IoAPC* _initAPCVATGV_0(){
	static IoAPC staticAPCVATGV("IoAPC","APCVATGV",MODULE_NAME);
	IoAPC::poAPCVATGV=&staticAPCVATGV;
	IoAPC* dev=&staticAPCVATGV;
	strcpy(dev->id,"APCVATGV");
	strcpy(dev->display,"APCVATGV");
	strcpy(dev->schematicId,"APCVATGV");
	strcpy(dev->unit,"");
	dev->aiValueSensorInput1.create("aiValueSensorInput1",&AI->Pressure_Sensor_1,"AI.Pressure_Sensor_1",TRUE);
	dev->aiValueSensorInput2.create("aiValueSensorInput2",&AI->Pressure_Sensor_2,"AI.Pressure_Sensor_2",TRUE);
	dev->aiPositionActualValue.create("aiPositionActualValue",&AI->Actual_Position,"AI.Actual_Position",TRUE);
	dev->aiSpecifyControlMode.create("aiSpecifyControlMode",&AI->Control_Mode,"AI.Control_Mode",TRUE);
	dev->aiActualPressure.create("aiActualPressure",&AI->Actual_Pressure,"AI.Actual_Pressure",TRUE);
	dev->aiErrorNumber.create("aiErrorNumber",&AI->Error_Number,"AI.Error_Number",TRUE);
	return dev;
}
IoAPC* _initAPCVATGV_1(IoAPC *dev){
	dev->aiGeneralStatus.create("aiGeneralStatus",&AI->General_Status,"AI.General_Status",TRUE);
	dev->aiGeneralWarnings.create("aiGeneralWarnings",&AI->General_Warnings,"AI.General_Warnings",TRUE);
	dev->aiExtendedWarnings.create("aiExtendedWarnings",&AI->Extended_Warnings,"AI.Extended_Warnings",TRUE);
	dev->aoSpecifyTargetVacuumPressureControl.create("aoSpecifyTargetVacuumPressureControl",&AO->Target_Pressure,"AO.Target_Pressure",FALSE);
	dev->aoSpecifyTargetOpeningForValveOpeningControl.create("aoSpecifyTargetOpeningForValveOpeningControl",&AO->Target_Position,"AO.Target_Position",FALSE);
	dev->aoPressureInputDigitalSensor1.create("aoPressureInputDigitalSensor1",&AO->Pressure_Input_Digital_Sensor_1,"AO.Pressure_Input_Digital_Sensor_1",FALSE);
	dev->aoPressureInputDigitalSensor2.create("aoPressureInputDigitalSensor2",&AO->Pressure_Input_Digital_Sensor_2,"AO.Pressure_Input_Digital_Sensor_2",FALSE);
	dev->aoSpecifyControlMode.create("aoSpecifyControlMode",&AO->Control_Mode,"AO.Control_Mode",FALSE);
	dev->aoControllerModeSelect.create("aoControllerModeSelect",&AO->General_Control_Setpoint,"AO.General_Control_Setpoint",FALSE);
	dev->aoSlowVacuumRate.create("aoSlowVacuumRate",&AO->Pressure_Ramp_Time,"AO.Pressure_Ramp_Time",FALSE);
	return dev;
}
IoAPC* _initAPCVATGV_2(IoAPC *dev){
	strcpy(dev->scRootPath,"");
	strcpy(dev->aioType,"float");
	return dev;
}
IoAPC* _initAPC_0(){
	static IoAPC staticAPC("IoAPC","APC",MODULE_NAME);
	IoAPC::poAPC=&staticAPC;
	IoAPC* dev=&staticAPC;
	strcpy(dev->id,"APC");
	strcpy(dev->display,"APC");
	strcpy(dev->schematicId,"APC");
	strcpy(dev->unit,"");
	dev->aiValueSensorInput1.create("aiValueSensorInput1",&AI->CKD_APC_Value_Sensor_Input1,"AI.CKD_APC_Value_Sensor_Input1",TRUE);
	dev->aiValueSensorInput2.create("aiValueSensorInput2",&AI->CKD_APC_Value_Sensor_Input2,"AI.CKD_APC_Value_Sensor_Input2",TRUE);
	dev->aiSelectController.create("aiSelectController");
	dev->aiPositionActualValue.create("aiPositionActualValue",&AI->CKD_APC_Position_Actual_Value,"AI.CKD_APC_Position_Actual_Value",TRUE);
	dev->aiControlModeStatus.create("aiControlModeStatus",&AI->CKD_APC_Control_Mode_Status,"AI.CKD_APC_Control_Mode_Status",TRUE);
	dev->aiHomeStatus.create("aiHomeStatus",&AI->CKD_APC_Homing_Status,"AI.CKD_APC_Homing_Status",TRUE);
	return dev;
}
IoAPC* _initAPC_1(IoAPC *dev){
	dev->aiWarningStatus1.create("aiWarningStatus1",&AI->CKD_APC_Device_Management_Device_Warning_Details,"AI.CKD_APC_Device_Management_Device_Warning_Details",TRUE);
	dev->aiWarningStatus2.create("aiWarningStatus2",&AI->CKD_APC_Sensor_Input1_Device_Warning_Details,"AI.CKD_APC_Sensor_Input1_Device_Warning_Details",TRUE);
	dev->aiWarningStatus3.create("aiWarningStatus3",&AI->CKD_APC_Sensor_Input2_Device_Warning_Details,"AI.CKD_APC_Sensor_Input2_Device_Warning_Details",TRUE);
	dev->aiWarningStatus4.create("aiWarningStatus4",&AI->CKD_APC_Process_Controller_Selector_Device_Warning_Details,"AI.CKD_APC_Process_Controller_Selector_Device_Warning_Details",TRUE);
	dev->aiWarningStatus5.create("aiWarningStatus5",&AI->CKD_APC_Valve_Device_Warning_Details,"AI.CKD_APC_Valve_Device_Warning_Details",TRUE);
	dev->aiWarningStatus6.create("aiWarningStatus6",&AI->CKD_APC_Valve_manufacturer_Warning_Details,"AI.CKD_APC_Valve_manufacturer_Warning_Details",TRUE);
	dev->aiErrorStatus1.create("aiErrorStatus1",&AI->CKD_APC_Device_Management_manufacturer_Error_Details,"AI.CKD_APC_Device_Management_manufacturer_Error_Details",TRUE);
	dev->aiErrorStatus2.create("aiErrorStatus2",&AI->CKD_APC_Sensor_Input1_Management_manufacturer_Error_Details,"AI.CKD_APC_Sensor_Input1_Management_manufacturer_Error_Details",TRUE);
	dev->aiErrorStatus3.create("aiErrorStatus3",&AI->CKD_APC_Sensor_Input2_Management_manufacturer_Error_Details,"AI.CKD_APC_Sensor_Input2_Management_manufacturer_Error_Details",TRUE);
	dev->aiErrorStatus4.create("aiErrorStatus4",&AI->CKD_APC_Valve_Management_manufacturer_Error_Details,"AI.CKD_APC_Valve_Management_manufacturer_Error_Details",TRUE);
	return dev;
}
IoAPC* _initAPC_2(IoAPC *dev){
	dev->aiValveStatusThreshold.create("aiValveStatusThreshold",&AI->CKD_APC_Valve_status_threshold,"AI.CKD_APC_Valve_status_threshold",TRUE);
	dev->aiSlowVacuumModeSetting.create("aiSlowVacuumModeSetting",&AI->CKD_APC_Slow_vacuum_mode_setting,"AI.CKD_APC_Slow_vacuum_mode_setting",TRUE);
	dev->aiInterlock1.create("aiInterlock1",&AI->CKD_APC_Interlock1,"AI.CKD_APC_Interlock1",TRUE);
	dev->aiInterlock2.create("aiInterlock2",&AI->CKD_APC_Interlock2,"AI.CKD_APC_Interlock2",TRUE);
	dev->aiInterlock3.create("aiInterlock3",&AI->CKD_APC_Interlock3,"AI.CKD_APC_Interlock3",TRUE);
	dev->aiInterlockConstantOfInterlock3.create("aiInterlockConstantOfInterlock3",&AI->CKD_APC_Interlock_constant_of_interlock3,"AI.CKD_APC_Interlock_constant_of_interlock3",TRUE);
	dev->aiP1SensorOffsetSetting.create("aiP1SensorOffsetSetting",&AI->CKD_APC_P1_sensor_offset_setting,"AI.CKD_APC_P1_sensor_offset_setting",TRUE);
	dev->aiPosMonOffsetSetting.create("aiPosMonOffsetSetting",&AI->CKD_APC_Pos_mon_offset_setting,"AI.CKD_APC_Pos_mon_offset_setting",TRUE);
	dev->diP1ZeroOffsetOutRangeAlm.create("diP1ZeroOffsetOutRangeAlm");
	dev->diP1ZeroAdjOutRangeAlm.create("diP1ZeroAdjOutRangeAlm");
	return dev;
}
IoAPC* _initAPC_3(IoAPC *dev){
	dev->diP1SpanAdjOutRangeAlm.create("diP1SpanAdjOutRangeAlm");
	dev->diP2ZeroOffsetOutRangeAlm.create("diP2ZeroOffsetOutRangeAlm");
	dev->diP2ZeroAdjOutRangeAlm.create("diP2ZeroAdjOutRangeAlm");
	dev->diP2SpanAdjOutRangeAlm.create("diP2SpanAdjOutRangeAlm");
	dev->diP1PressCtrlInterlockAlm.create("diP1PressCtrlInterlockAlm");
	dev->diP2PressCtrlInterlockAlm.create("diP2PressCtrlInterlockAlm");
	dev->diValveOpenCtrlInterlockAlm.create("diValveOpenCtrlInterlockAlm");
	dev->diValveHoldCtrlInterlockAlm.create("diValveHoldCtrlInterlockAlm");
	dev->diValveCloseInterlockAlm.create("diValveCloseInterlockAlm");
	dev->diAutoTeachingInterlockAlm.create("diAutoTeachingInterlockAlm");
	return dev;
}
IoAPC* _initAPC_4(IoAPC *dev){
	dev->diP1DisconnectionAlm.create("diP1DisconnectionAlm");
	dev->diP2DisconnectionAlm.create("diP2DisconnectionAlm");
	dev->diPumpStopInterlockAlm.create("diPumpStopInterlockAlm");
	dev->diAutoTeachingErr1Alm.create("diAutoTeachingErr1Alm");
	dev->diAutoTeachingErr2Alm.create("diAutoTeachingErr2Alm");
	dev->doValve.create("doValve");
	dev->doVGUnit.create("doVGUnit",&NDO->Sys_VGUnitConversion_b,"NDO.Sys_VGUnitConversion_b",FALSE);
	dev->doAoDataReadSysConfig.create("doAoDataReadSysConfig",&NDO->Sys_APC_DATA_READ_SYSCONFIG,"NDO.Sys_APC_DATA_READ_SYSCONFIG",FALSE);
	dev->doAoDataWriteSysConfig.create("doAoDataWriteSysConfig",&NDO->Sys_APC_DATA_WRITE_SYSCONFIG,"NDO.Sys_APC_DATA_WRITE_SYSCONFIG",FALSE);
	dev->doAoDataReadCusConfig.create("doAoDataReadCusConfig",&NDO->Sys_APC_DATA_READ_CUSCONFIG,"NDO.Sys_APC_DATA_READ_CUSCONFIG",FALSE);
	return dev;
}
IoAPC* _initAPC_5(IoAPC *dev){
	dev->doAoDataWriteCusConfig.create("doAoDataWriteCusConfig",&NDO->Sys_APC_DATA_WRITE_CUSCONFIG,"NDO.Sys_APC_DATA_WRITE_CUSCONFIG",FALSE);
	dev->aoZeroResetP1.create("aoZeroResetP1");
	dev->aoZeroAdjustP1.create("aoZeroAdjustP1");
	dev->aoSpanAdjustP1.create("aoSpanAdjustP1");
	dev->aoZeroResetP2.create("aoZeroResetP2");
	dev->aoZeroAdjustP2.create("aoZeroAdjustP2");
	dev->aoSpanAdjustP2.create("aoSpanAdjustP2");
	dev->aoSlowVacuumTargetPressure.create("aoSlowVacuumTargetPressure",&AO->CKD_APC_Slow_exhaust_control_arrival_pressure,"AO.CKD_APC_Slow_exhaust_control_arrival_pressure",FALSE);
	dev->aoValveStatusThreshold.create("aoValveStatusThreshold",&AO->CKD_APC_Valve_status_threshold,"AO.CKD_APC_Valve_status_threshold",FALSE);
	dev->aoForbidInterlockOutbreak.create("aoForbidInterlockOutbreak",&AO->CKD_APC_Forbid_interlock_outbreak,"AO.CKD_APC_Forbid_interlock_outbreak",FALSE);
	return dev;
}
IoAPC* _initAPC_6(IoAPC *dev){
	dev->aoSlowVacuumModeSetting.create("aoSlowVacuumModeSetting",&AO->CKD_APC_Slow_vacuum_mode_setting,"AO.CKD_APC_Slow_vacuum_mode_setting",FALSE);
	dev->aoInterlock1.create("aoInterlock1",&AO->CKD_APC_Interlock1,"AO.CKD_APC_Interlock1",FALSE);
	dev->aoInterlock2.create("aoInterlock2",&AO->CKD_APC_Interlock2,"AO.CKD_APC_Interlock2",FALSE);
	dev->aoInterlock3.create("aoInterlock3",&AO->CKD_APC_Interlock3,"AO.CKD_APC_Interlock3",FALSE);
	dev->aoInterlockConstantOfInterlock3.create("aoInterlockConstantOfInterlock3",&AO->CKD_APC_Interlock_constant_of_interlock3,"AO.CKD_APC_Interlock_constant_of_interlock3",FALSE);
	dev->aoP1SensorOffsetSetting.create("aoP1SensorOffsetSetting",&AO->CKD_APC_P1_sensor_offset_setting,"AO.CKD_APC_P1_sensor_offset_setting",FALSE);
	dev->aoPosMonOffsetSetting.create("aoPosMonOffsetSetting",&AO->CKD_APC_Pos_mon_offset_setting,"AO.CKD_APC_Pos_mon_offset_setting",FALSE);
	dev->aoSensorAdjustReset.create("aoSensorAdjustReset",&AO->CKD_APC_Sensor_adjust_reset,"AO.CKD_APC_Sensor_adjust_reset",FALSE);
	dev->aoSlowVacuumRate.create("aoSlowVacuumRate",&AO->CKD_APC_Exh_Rate,"AO.CKD_APC_Exh_Rate",FALSE);
	dev->aoSlowVacuumP.create("aoSlowVacuumP",&AO->CKD_APC_Slow_vacuum_control_P,"AO.CKD_APC_Slow_vacuum_control_P",FALSE);
	return dev;
}
IoAPC* _initAPC_7(IoAPC *dev){
	dev->aoSlowVacuumI.create("aoSlowVacuumI",&AO->CKD_APC_Slow_vacuum_control_I,"AO.CKD_APC_Slow_vacuum_control_I",FALSE);
	dev->aoSlowVacuumD.create("aoSlowVacuumD",&AO->CKD_APC_Slow_vacuum_control_D,"AO.CKD_APC_Slow_vacuum_control_D",FALSE);
	dev->aoSlowVacuumA.create("aoSlowVacuumA",&AO->CKD_APC_Slow_vacuum_control_a,"AO.CKD_APC_Slow_vacuum_control_a",FALSE);
	dev->aiSlowVacuumP.create("aiSlowVacuumP",&AI->CKD_APC_Slow_vacuum_control_P,"AI.CKD_APC_Slow_vacuum_control_P",TRUE);
	dev->aiSlowVacuumI.create("aiSlowVacuumI",&AI->CKD_APC_Slow_vacuum_control_I,"AI.CKD_APC_Slow_vacuum_control_I",TRUE);
	dev->aiSlowVacuumD.create("aiSlowVacuumD",&AI->CKD_APC_Slow_vacuum_control_D,"AI.CKD_APC_Slow_vacuum_control_D",TRUE);
	dev->aiSlowVacuumA.create("aiSlowVacuumA",&AI->CKD_APC_Slow_vacuum_control_a,"AI.CKD_APC_Slow_vacuum_control_a",TRUE);
	dev->aoControllerModeSelect.create("aoControllerModeSelect",&AO->CKD_APC_Active_Controller,"AO.CKD_APC_Active_Controller",FALSE);
	dev->aoSpecifyTargetVacuumPressureControl.create("aoSpecifyTargetVacuumPressureControl",&AO->CKD_APC_Process_Setpoint,"AO.CKD_APC_Process_Setpoint",FALSE);
	dev->aoSpecifyTargetOpeningForValveOpeningControl.create("aoSpecifyTargetOpeningForValveOpeningControl",&AO->CKD_APC_Position_Setpoint,"AO.CKD_APC_Position_Setpoint",FALSE);
	return dev;
}
IoAPC* _initAPC_8(IoAPC *dev){
	dev->aoSpecifyControlMode.create("aoSpecifyControlMode",&AO->CKD_APC_Control_Mode,"AO.CKD_APC_Control_Mode",FALSE);
	dev->aoCKDAPCExhRate.create("aoCKDAPCExhRate",&AO->CKD_APC_Exh_Rate,"AO.CKD_APC_Exh_Rate",FALSE);
	dev->aoRangeUpperLimitSensorInput.create("aoRangeUpperLimitSensorInput",&AO->CKD_APC_Range_Upper_Limit_Sensor_Input1,"AO.CKD_APC_Range_Upper_Limit_Sensor_Input1",FALSE);
	dev->aoRangeUpperLimitSensorInput2.create("aoRangeUpperLimitSensorInput2",&AO->CKD_APC_Range_Upper_Limit_Sensor_Input2,"AO.CKD_APC_Range_Upper_Limit_Sensor_Input2",FALSE);
	dev->aoController1.create("aoController1");
	dev->aoController1P.create("aoController1P",&AO->CKD_APC_P_constant_for_process_controller1,"AO.CKD_APC_P_constant_for_process_controller1",FALSE);
	dev->aoController1I.create("aoController1I",&AO->CKD_APC_I_constant_for_process_controller1,"AO.CKD_APC_I_constant_for_process_controller1",FALSE);
	dev->aoController1D.create("aoController1D",&AO->CKD_APC_D_constant_for_process_controller1,"AO.CKD_APC_D_constant_for_process_controller1",FALSE);
	dev->aoController1A.create("aoController1A",&AO->CKD_APC_a_sensor_differential_controller1,"AO.CKD_APC_a_sensor_differential_controller1",FALSE);
	dev->aoController1CH.create("aoController1CH",&AO->CKD_APC_CH_controller1,"AO.CKD_APC_CH_controller1",FALSE);
	return dev;
}
IoAPC* _initAPC_9(IoAPC *dev){
	dev->aoController1CL.create("aoController1CL",&AO->CKD_APC_CL1_controller1,"AO.CKD_APC_CL1_controller1",FALSE);
	dev->aoController1Offset.create("aoController1Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_1,"AO.CKD_APC_OFFSET_for_Pocess_Controller_1",FALSE);
	dev->aoController2.create("aoController2");
	dev->aoController2P.create("aoController2P",&AO->CKD_APC_P_constant_for_process_controller2,"AO.CKD_APC_P_constant_for_process_controller2",FALSE);
	dev->aoController2I.create("aoController2I",&AO->CKD_APC_I_constant_for_process_controller2,"AO.CKD_APC_I_constant_for_process_controller2",FALSE);
	dev->aoController2D.create("aoController2D",&AO->CKD_APC_D_constant_for_process_controller2,"AO.CKD_APC_D_constant_for_process_controller2",FALSE);
	dev->aoController2A.create("aoController2A",&AO->CKD_APC_a_sensor_differential_controller2,"AO.CKD_APC_a_sensor_differential_controller2",FALSE);
	dev->aoController2CH.create("aoController2CH",&AO->CKD_APC_CH_controller2,"AO.CKD_APC_CH_controller2",FALSE);
	dev->aoController2CL.create("aoController2CL",&AO->CKD_APC_CL1_controller2,"AO.CKD_APC_CL1_controller2",FALSE);
	dev->aoController2Offset.create("aoController2Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_2,"AO.CKD_APC_OFFSET_for_Pocess_Controller_2",FALSE);
	return dev;
}
IoAPC* _initAPC_10(IoAPC *dev){
	dev->aoController3.create("aoController3");
	dev->aoController3P.create("aoController3P",&AO->CKD_APC_P_constant_for_process_controller3,"AO.CKD_APC_P_constant_for_process_controller3",FALSE);
	dev->aoController3I.create("aoController3I",&AO->CKD_APC_I_constant_for_process_controller3,"AO.CKD_APC_I_constant_for_process_controller3",FALSE);
	dev->aoController3D.create("aoController3D",&AO->CKD_APC_D_constant_for_process_controller3,"AO.CKD_APC_D_constant_for_process_controller3",FALSE);
	dev->aoController3A.create("aoController3A",&AO->CKD_APC_a_sensor_differential_controller3,"AO.CKD_APC_a_sensor_differential_controller3",FALSE);
	dev->aoController3CH.create("aoController3CH",&AO->CKD_APC_CH_controller3,"AO.CKD_APC_CH_controller3",FALSE);
	dev->aoController3CL.create("aoController3CL",&AO->CKD_APC_CL1_controller3,"AO.CKD_APC_CL1_controller3",FALSE);
	dev->aoController3Offset.create("aoController3Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_3,"AO.CKD_APC_OFFSET_for_Pocess_Controller_3",FALSE);
	dev->aoController4.create("aoController4");
	dev->aoController4P.create("aoController4P",&AO->CKD_APC_P_constant_for_process_controller4,"AO.CKD_APC_P_constant_for_process_controller4",FALSE);
	return dev;
}
IoAPC* _initAPC_11(IoAPC *dev){
	dev->aoController4I.create("aoController4I",&AO->CKD_APC_I_constant_for_process_controller4,"AO.CKD_APC_I_constant_for_process_controller4",FALSE);
	dev->aoController4D.create("aoController4D",&AO->CKD_APC_D_constant_for_process_controller4,"AO.CKD_APC_D_constant_for_process_controller4",FALSE);
	dev->aoController4A.create("aoController4A",&AO->CKD_APC_a_sensor_differential_controller4,"AO.CKD_APC_a_sensor_differential_controller4",FALSE);
	dev->aoController4CH.create("aoController4CH",&AO->CKD_APC_CH_controller4,"AO.CKD_APC_CH_controller4",FALSE);
	dev->aoController4CL.create("aoController4CL",&AO->CKD_APC_CL1_controller4,"AO.CKD_APC_CL1_controller4",FALSE);
	dev->aoController4Offset.create("aoController4Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_4,"AO.CKD_APC_OFFSET_for_Pocess_Controller_4",FALSE);
	dev->aoController5.create("aoController5");
	dev->aoController5P.create("aoController5P",&AO->CKD_APC_P_constant_for_process_controller5,"AO.CKD_APC_P_constant_for_process_controller5",FALSE);
	dev->aoController5I.create("aoController5I",&AO->CKD_APC_I_constant_for_process_controller5,"AO.CKD_APC_I_constant_for_process_controller5",FALSE);
	dev->aoController5D.create("aoController5D",&AO->CKD_APC_D_constant_for_process_controller5,"AO.CKD_APC_D_constant_for_process_controller5",FALSE);
	return dev;
}
IoAPC* _initAPC_12(IoAPC *dev){
	dev->aoController5A.create("aoController5A",&AO->CKD_APC_a_sensor_differential_controller5,"AO.CKD_APC_a_sensor_differential_controller5",FALSE);
	dev->aoController5CH.create("aoController5CH",&AO->CKD_APC_CH_controller5,"AO.CKD_APC_CH_controller5",FALSE);
	dev->aoController5CL.create("aoController5CL",&AO->CKD_APC_CL1_controller5,"AO.CKD_APC_CL1_controller5",FALSE);
	dev->aoController5Offset.create("aoController5Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_5,"AO.CKD_APC_OFFSET_for_Pocess_Controller_5",FALSE);
	dev->aoController6.create("aoController6");
	dev->aoController6P.create("aoController6P",&AO->CKD_APC_P_constant_for_process_controller6,"AO.CKD_APC_P_constant_for_process_controller6",FALSE);
	dev->aoController6I.create("aoController6I",&AO->CKD_APC_I_constant_for_process_controller6,"AO.CKD_APC_I_constant_for_process_controller6",FALSE);
	dev->aoController6D.create("aoController6D",&AO->CKD_APC_D_constant_for_process_controller6,"AO.CKD_APC_D_constant_for_process_controller6",FALSE);
	dev->aoController6A.create("aoController6A",&AO->CKD_APC_a_sensor_differential_controller6,"AO.CKD_APC_a_sensor_differential_controller6",FALSE);
	dev->aoController6CH.create("aoController6CH",&AO->CKD_APC_CH_controller6,"AO.CKD_APC_CH_controller6",FALSE);
	return dev;
}
IoAPC* _initAPC_13(IoAPC *dev){
	dev->aoController6CL.create("aoController6CL",&AO->CKD_APC_CL1_controller6,"AO.CKD_APC_CL1_controller6",FALSE);
	dev->aoController6Offset.create("aoController6Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_6,"AO.CKD_APC_OFFSET_for_Pocess_Controller_6",FALSE);
	dev->aoController7.create("aoController7");
	dev->aoController7P.create("aoController7P",&AO->CKD_APC_P_constant_for_process_controller7,"AO.CKD_APC_P_constant_for_process_controller7",FALSE);
	dev->aoController7I.create("aoController7I",&AO->CKD_APC_I_constant_for_process_controller7,"AO.CKD_APC_I_constant_for_process_controller7",FALSE);
	dev->aoController7D.create("aoController7D",&AO->CKD_APC_D_constant_for_process_controller7,"AO.CKD_APC_D_constant_for_process_controller7",FALSE);
	dev->aoController7A.create("aoController7A",&AO->CKD_APC_a_sensor_differential_controller7,"AO.CKD_APC_a_sensor_differential_controller7",FALSE);
	dev->aoController7CH.create("aoController7CH",&AO->CKD_APC_CH_controller7,"AO.CKD_APC_CH_controller7",FALSE);
	dev->aoController7CL.create("aoController7CL",&AO->CKD_APC_CL1_controller7,"AO.CKD_APC_CL1_controller7",FALSE);
	dev->aoController7Offset.create("aoController7Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_7,"AO.CKD_APC_OFFSET_for_Pocess_Controller_7",FALSE);
	return dev;
}
IoAPC* _initAPC_14(IoAPC *dev){
	dev->aoController8.create("aoController8");
	dev->aoController8P.create("aoController8P",&AO->CKD_APC_P_constant_for_process_controller8,"AO.CKD_APC_P_constant_for_process_controller8",FALSE);
	dev->aoController8I.create("aoController8I",&AO->CKD_APC_I_constant_for_process_controller8,"AO.CKD_APC_I_constant_for_process_controller8",FALSE);
	dev->aoController8D.create("aoController8D",&AO->CKD_APC_D_constant_for_process_controller8,"AO.CKD_APC_D_constant_for_process_controller8",FALSE);
	dev->aoController8A.create("aoController8A",&AO->CKD_APC_a_sensor_differential_controller8,"AO.CKD_APC_a_sensor_differential_controller8",FALSE);
	dev->aoController8CH.create("aoController8CH",&AO->CKD_APC_CH_controller8,"AO.CKD_APC_CH_controller8",FALSE);
	dev->aoController8CL.create("aoController8CL",&AO->CKD_APC_CL1_controller8,"AO.CKD_APC_CL1_controller8",FALSE);
	dev->aoController8Offset.create("aoController8Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_8,"AO.CKD_APC_OFFSET_for_Pocess_Controller_8",FALSE);
	dev->aoController9.create("aoController9");
	dev->aoController9P.create("aoController9P",&AO->CKD_APC_P_constant_for_process_controller9,"AO.CKD_APC_P_constant_for_process_controller9",FALSE);
	return dev;
}
IoAPC* _initAPC_15(IoAPC *dev){
	dev->aoController9I.create("aoController9I",&AO->CKD_APC_I_constant_for_process_controller9,"AO.CKD_APC_I_constant_for_process_controller9",FALSE);
	dev->aoController9D.create("aoController9D",&AO->CKD_APC_D_constant_for_process_controller9,"AO.CKD_APC_D_constant_for_process_controller9",FALSE);
	dev->aoController9A.create("aoController9A",&AO->CKD_APC_a_sensor_differential_controller9,"AO.CKD_APC_a_sensor_differential_controller9",FALSE);
	dev->aoController9CH.create("aoController9CH",&AO->CKD_APC_CH_controller9,"AO.CKD_APC_CH_controller9",FALSE);
	dev->aoController9CL.create("aoController9CL",&AO->CKD_APC_CL1_controller9,"AO.CKD_APC_CL1_controller9",FALSE);
	dev->aoController9Offset.create("aoController9Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_9,"AO.CKD_APC_OFFSET_for_Pocess_Controller_9",FALSE);
	dev->aoController10.create("aoController10");
	dev->aoController10P.create("aoController10P",&AO->CKD_APC_P_constant_for_process_controller10,"AO.CKD_APC_P_constant_for_process_controller10",FALSE);
	dev->aoController10I.create("aoController10I",&AO->CKD_APC_I_constant_for_process_controller10,"AO.CKD_APC_I_constant_for_process_controller10",FALSE);
	dev->aoController10D.create("aoController10D",&AO->CKD_APC_D_constant_for_process_controller10,"AO.CKD_APC_D_constant_for_process_controller10",FALSE);
	return dev;
}
IoAPC* _initAPC_16(IoAPC *dev){
	dev->aoController10A.create("aoController10A",&AO->CKD_APC_a_sensor_differential_controller10,"AO.CKD_APC_a_sensor_differential_controller10",FALSE);
	dev->aoController10CH.create("aoController10CH",&AO->CKD_APC_CH_controller10,"AO.CKD_APC_CH_controller10",FALSE);
	dev->aoController10CL.create("aoController10CL",&AO->CKD_APC_CL1_controller10,"AO.CKD_APC_CL1_controller10",FALSE);
	dev->aoController10Offset.create("aoController10Offset",&AO->CKD_APC_OFFSET_for_Pocess_Controller_10,"AO.CKD_APC_OFFSET_for_Pocess_Controller_10",FALSE);
	dev->aiController1P.create("aiController1P",&AI->CKD_APC_P_constant_for_process_controller1,"AI.CKD_APC_P_constant_for_process_controller1",TRUE);
	dev->aiController1I.create("aiController1I",&AI->CKD_APC_I_constant_for_process_controller1,"AI.CKD_APC_I_constant_for_process_controller1",TRUE);
	dev->aiController1D.create("aiController1D",&AI->CKD_APC_D_constant_for_process_controller1,"AI.CKD_APC_D_constant_for_process_controller1",TRUE);
	dev->aiController1A.create("aiController1A",&AI->CKD_APC_a_sensor_differential_controller1,"AI.CKD_APC_a_sensor_differential_controller1",TRUE);
	dev->aiController1CH.create("aiController1CH",&AI->CKD_APC_CH_controller1,"AI.CKD_APC_CH_controller1",TRUE);
	dev->aiController1CL.create("aiController1CL",&AI->CKD_APC_CL1_controller1,"AI.CKD_APC_CL1_controller1",TRUE);
	return dev;
}
IoAPC* _initAPC_17(IoAPC *dev){
	dev->aiController1Offset.create("aiController1Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_1,"AI.CKD_APC_OFFSET_for_Pocess_Controller_1",TRUE);
	dev->aiController2.create("aiController2");
	dev->aiController2P.create("aiController2P",&AI->CKD_APC_P_constant_for_process_controller2,"AI.CKD_APC_P_constant_for_process_controller2",TRUE);
	dev->aiController2I.create("aiController2I",&AI->CKD_APC_I_constant_for_process_controller2,"AI.CKD_APC_I_constant_for_process_controller2",TRUE);
	dev->aiController2D.create("aiController2D",&AI->CKD_APC_D_constant_for_process_controller2,"AI.CKD_APC_D_constant_for_process_controller2",TRUE);
	dev->aiController2A.create("aiController2A",&AI->CKD_APC_a_sensor_differential_controller2,"AI.CKD_APC_a_sensor_differential_controller2",TRUE);
	dev->aiController2CH.create("aiController2CH",&AI->CKD_APC_CH_controller2,"AI.CKD_APC_CH_controller2",TRUE);
	dev->aiController2CL.create("aiController2CL",&AI->CKD_APC_CL1_controller2,"AI.CKD_APC_CL1_controller2",TRUE);
	dev->aiController2Offset.create("aiController2Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_2,"AI.CKD_APC_OFFSET_for_Pocess_Controller_2",TRUE);
	dev->aiController3.create("aiController3");
	return dev;
}
IoAPC* _initAPC_18(IoAPC *dev){
	dev->aiController3P.create("aiController3P",&AI->CKD_APC_P_constant_for_process_controller3,"AI.CKD_APC_P_constant_for_process_controller3",TRUE);
	dev->aiController3I.create("aiController3I",&AI->CKD_APC_I_constant_for_process_controller3,"AI.CKD_APC_I_constant_for_process_controller3",TRUE);
	dev->aiController3D.create("aiController3D",&AI->CKD_APC_D_constant_for_process_controller3,"AI.CKD_APC_D_constant_for_process_controller3",TRUE);
	dev->aiController3A.create("aiController3A",&AI->CKD_APC_a_sensor_differential_controller3,"AI.CKD_APC_a_sensor_differential_controller3",TRUE);
	dev->aiController3CH.create("aiController3CH",&AI->CKD_APC_CH_controller3,"AI.CKD_APC_CH_controller3",TRUE);
	dev->aiController3CL.create("aiController3CL",&AI->CKD_APC_CL1_controller3,"AI.CKD_APC_CL1_controller3",TRUE);
	dev->aiController3Offset.create("aiController3Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_3,"AI.CKD_APC_OFFSET_for_Pocess_Controller_3",TRUE);
	dev->aiController4.create("aiController4");
	dev->aiController4P.create("aiController4P",&AI->CKD_APC_P_constant_for_process_controller4,"AI.CKD_APC_P_constant_for_process_controller4",TRUE);
	dev->aiController4I.create("aiController4I",&AI->CKD_APC_I_constant_for_process_controller4,"AI.CKD_APC_I_constant_for_process_controller4",TRUE);
	return dev;
}
IoAPC* _initAPC_19(IoAPC *dev){
	dev->aiController4D.create("aiController4D",&AI->CKD_APC_D_constant_for_process_controller4,"AI.CKD_APC_D_constant_for_process_controller4",TRUE);
	dev->aiController4A.create("aiController4A",&AI->CKD_APC_a_sensor_differential_controller4,"AI.CKD_APC_a_sensor_differential_controller4",TRUE);
	dev->aiController4CH.create("aiController4CH",&AI->CKD_APC_CH_controller4,"AI.CKD_APC_CH_controller4",TRUE);
	dev->aiController4CL.create("aiController4CL",&AI->CKD_APC_CL1_controller4,"AI.CKD_APC_CL1_controller4",TRUE);
	dev->aiController4Offset.create("aiController4Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_4,"AI.CKD_APC_OFFSET_for_Pocess_Controller_4",TRUE);
	dev->aiController5.create("aiController5");
	dev->aiController5P.create("aiController5P",&AI->CKD_APC_P_constant_for_process_controller5,"AI.CKD_APC_P_constant_for_process_controller5",TRUE);
	dev->aiController5I.create("aiController5I",&AI->CKD_APC_I_constant_for_process_controller5,"AI.CKD_APC_I_constant_for_process_controller5",TRUE);
	dev->aiController5D.create("aiController5D",&AI->CKD_APC_D_constant_for_process_controller5,"AI.CKD_APC_D_constant_for_process_controller5",TRUE);
	dev->aiController5A.create("aiController5A",&AI->CKD_APC_a_sensor_differential_controller5,"AI.CKD_APC_a_sensor_differential_controller5",TRUE);
	return dev;
}
IoAPC* _initAPC_20(IoAPC *dev){
	dev->aiController5CH.create("aiController5CH",&AI->CKD_APC_CH_controller5,"AI.CKD_APC_CH_controller5",TRUE);
	dev->aiController5CL.create("aiController5CL",&AI->CKD_APC_CL1_controller5,"AI.CKD_APC_CL1_controller5",TRUE);
	dev->aiController5Offset.create("aiController5Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_5,"AI.CKD_APC_OFFSET_for_Pocess_Controller_5",TRUE);
	dev->aiController6.create("aiController6");
	dev->aiController6P.create("aiController6P",&AI->CKD_APC_P_constant_for_process_controller6,"AI.CKD_APC_P_constant_for_process_controller6",TRUE);
	dev->aiController6I.create("aiController6I",&AI->CKD_APC_I_constant_for_process_controller6,"AI.CKD_APC_I_constant_for_process_controller6",TRUE);
	dev->aiController6D.create("aiController6D",&AI->CKD_APC_D_constant_for_process_controller6,"AI.CKD_APC_D_constant_for_process_controller6",TRUE);
	dev->aiController6A.create("aiController6A",&AI->CKD_APC_a_sensor_differential_controller6,"AI.CKD_APC_a_sensor_differential_controller6",TRUE);
	dev->aiController6CH.create("aiController6CH",&AI->CKD_APC_CH_controller6,"AI.CKD_APC_CH_controller6",TRUE);
	dev->aiController6CL.create("aiController6CL",&AI->CKD_APC_CL1_controller6,"AI.CKD_APC_CL1_controller6",TRUE);
	return dev;
}
IoAPC* _initAPC_21(IoAPC *dev){
	dev->aiController6Offset.create("aiController6Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_6,"AI.CKD_APC_OFFSET_for_Pocess_Controller_6",TRUE);
	dev->aiController7.create("aiController7");
	dev->aiController7P.create("aiController7P",&AI->CKD_APC_P_constant_for_process_controller7,"AI.CKD_APC_P_constant_for_process_controller7",TRUE);
	dev->aiController7I.create("aiController7I",&AI->CKD_APC_I_constant_for_process_controller7,"AI.CKD_APC_I_constant_for_process_controller7",TRUE);
	dev->aiController7D.create("aiController7D",&AI->CKD_APC_D_constant_for_process_controller7,"AI.CKD_APC_D_constant_for_process_controller7",TRUE);
	dev->aiController7A.create("aiController7A",&AI->CKD_APC_a_sensor_differential_controller7,"AI.CKD_APC_a_sensor_differential_controller7",TRUE);
	dev->aiController7CH.create("aiController7CH",&AI->CKD_APC_CH_controller7,"AI.CKD_APC_CH_controller7",TRUE);
	dev->aiController7CL.create("aiController7CL",&AI->CKD_APC_CL1_controller7,"AI.CKD_APC_CL1_controller7",TRUE);
	dev->aiController7Offset.create("aiController7Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_7,"AI.CKD_APC_OFFSET_for_Pocess_Controller_7",TRUE);
	dev->aiController8.create("aiController8");
	return dev;
}
IoAPC* _initAPC_22(IoAPC *dev){
	dev->aiController8P.create("aiController8P",&AI->CKD_APC_P_constant_for_process_controller8,"AI.CKD_APC_P_constant_for_process_controller8",TRUE);
	dev->aiController8I.create("aiController8I",&AI->CKD_APC_I_constant_for_process_controller8,"AI.CKD_APC_I_constant_for_process_controller8",TRUE);
	dev->aiController8D.create("aiController8D",&AI->CKD_APC_D_constant_for_process_controller8,"AI.CKD_APC_D_constant_for_process_controller8",TRUE);
	dev->aiController8A.create("aiController8A",&AI->CKD_APC_a_sensor_differential_controller8,"AI.CKD_APC_a_sensor_differential_controller8",TRUE);
	dev->aiController8CH.create("aiController8CH",&AI->CKD_APC_CH_controller8,"AI.CKD_APC_CH_controller8",TRUE);
	dev->aiController8CL.create("aiController8CL",&AI->CKD_APC_CL1_controller8,"AI.CKD_APC_CL1_controller8",TRUE);
	dev->aiController8Offset.create("aiController8Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_8,"AI.CKD_APC_OFFSET_for_Pocess_Controller_8",TRUE);
	dev->aiController9.create("aiController9");
	dev->aiController9P.create("aiController9P",&AI->CKD_APC_P_constant_for_process_controller9,"AI.CKD_APC_P_constant_for_process_controller9",TRUE);
	dev->aiController9I.create("aiController9I",&AI->CKD_APC_I_constant_for_process_controller9,"AI.CKD_APC_I_constant_for_process_controller9",TRUE);
	return dev;
}
IoAPC* _initAPC_23(IoAPC *dev){
	dev->aiController9D.create("aiController9D",&AI->CKD_APC_D_constant_for_process_controller9,"AI.CKD_APC_D_constant_for_process_controller9",TRUE);
	dev->aiController9A.create("aiController9A",&AI->CKD_APC_a_sensor_differential_controller9,"AI.CKD_APC_a_sensor_differential_controller9",TRUE);
	dev->aiController9CH.create("aiController9CH",&AI->CKD_APC_CH_controller9,"AI.CKD_APC_CH_controller9",TRUE);
	dev->aiController9CL.create("aiController9CL",&AI->CKD_APC_CL1_controller9,"AI.CKD_APC_CL1_controller9",TRUE);
	dev->aiController9Offset.create("aiController9Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_9,"AI.CKD_APC_OFFSET_for_Pocess_Controller_9",TRUE);
	dev->aiController10.create("aiController10");
	dev->aiController10P.create("aiController10P",&AI->CKD_APC_P_constant_for_process_controller10,"AI.CKD_APC_P_constant_for_process_controller10",TRUE);
	dev->aiController10I.create("aiController10I",&AI->CKD_APC_I_constant_for_process_controller10,"AI.CKD_APC_I_constant_for_process_controller10",TRUE);
	dev->aiController10D.create("aiController10D",&AI->CKD_APC_D_constant_for_process_controller10,"AI.CKD_APC_D_constant_for_process_controller10",TRUE);
	dev->aiController10A.create("aiController10A",&AI->CKD_APC_a_sensor_differential_controller10,"AI.CKD_APC_a_sensor_differential_controller10",TRUE);
	return dev;
}
IoAPC* _initAPC_24(IoAPC *dev){
	dev->aiController10CH.create("aiController10CH",&AI->CKD_APC_CH_controller10,"AI.CKD_APC_CH_controller10",TRUE);
	dev->aiController10CL.create("aiController10CL",&AI->CKD_APC_CL1_controller10,"AI.CKD_APC_CL1_controller10",TRUE);
	dev->aiController10Offset.create("aiController10Offset",&AI->CKD_APC_OFFSET_for_Pocess_Controller_10,"AI.CKD_APC_OFFSET_for_Pocess_Controller_10",TRUE);
	strcpy(dev->scRootPath,"");
	strcpy(dev->aioType,"float");
	return dev;
}
void initIoAPC(){
	IoAPC* dev;
	dev=_initAPCVATGV_0();
	_initAPCVATGV_1(dev);
	_initAPCVATGV_2(dev);
	dev=_initAPC_0();
	_initAPC_1(dev);
	_initAPC_2(dev);
	_initAPC_3(dev);
	_initAPC_4(dev);
	_initAPC_5(dev);
	_initAPC_6(dev);
	_initAPC_7(dev);
	_initAPC_8(dev);
	_initAPC_9(dev);
	_initAPC_10(dev);
	_initAPC_11(dev);
	_initAPC_12(dev);
	_initAPC_13(dev);
	_initAPC_14(dev);
	_initAPC_15(dev);
	_initAPC_16(dev);
	_initAPC_17(dev);
	_initAPC_18(dev);
	_initAPC_19(dev);
	_initAPC_20(dev);
	_initAPC_21(dev);
	_initAPC_22(dev);
	_initAPC_23(dev);
	_initAPC_24(dev);
}
IoAPC* IoAPC::poAPCVATGV=NULL;
IoAPC* IoAPC::poAPC=NULL;
//AUTOIO_END
